package com.kringlamobil.model;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.entity.BufferedHttpEntity;
import org.apache.http.impl.client.DefaultHttpClient;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

public class ImageHandler {
	
    /**
     * Downloads an image to the image screen
     * @param Url, a Url string to and image
     * @return a bitmap from the given Url
     */
    public Bitmap DownloadImage(String URL)
    {        
        Bitmap bitmap = null;
        InputStream in = null;      
        URL imageUrl = null;
        try 
        {
    		try 
    		{
    			imageUrl = new URL(URL.replaceAll(" ", "%20"));
    		} 
    		catch (MalformedURLException e) 
    		{
    			throw new RuntimeException(e);
    		}    
            in = imageUrl.openConnection().getInputStream();
            bitmap = BitmapFactory.decodeStream(in);
            in.close();
                    	
       	 	HttpGet httpRequest = null; 
            try 
            {
            	httpRequest = new HttpGet(imageUrl.toURI()); 
            } 
            catch (URISyntaxException e) { e.printStackTrace(); }
            
            HttpClient httpclient = new DefaultHttpClient(); 
            HttpResponse response = (HttpResponse) httpclient.execute(httpRequest); 
            HttpEntity entity = response.getEntity(); 
            BufferedHttpEntity bufHttpEntity = new BufferedHttpEntity (entity); 
            in = bufHttpEntity.getContent(); 
            bitmap = BitmapFactory.decodeStream(in);
            in.close();
        } 
        catch (OutOfMemoryError e) 
        {            
        	try 
        	{
           	 	HttpGet httpRequest = null; 
                try 
                {
                	httpRequest = new HttpGet(imageUrl.toURI()); 
                } 
                catch (URISyntaxException ex) { e.printStackTrace(); }
                
                HttpClient httpclient = new DefaultHttpClient(); 
                HttpResponse response = (HttpResponse) httpclient.execute(httpRequest); 
                HttpEntity entity = response.getEntity(); 
                BufferedHttpEntity bufHttpEntity = new BufferedHttpEntity (entity); 
                in = bufHttpEntity.getContent(); 
				BitmapFactory.Options options = new BitmapFactory.Options();
				options.inSampleSize = 8;
                bitmap = BitmapFactory.decodeStream(in);  
	            in.close();
			} 
        	catch (OutOfMemoryError e1)
        	{				
				//e1.printStackTrace();
			} 
        	catch (IOException e1) 
        	{			
        		//e.printStackTrace();
			}        	
        } 
        catch (Exception e) 
        {		
        	//e.printStackTrace();
		}
        return bitmap;                
    }
}
